#############################################################################
##
##  PackageInfo.g file for the package openmath,
##  written by Marco Costantini in order to use this package with Gap 4.4
##

Revision.("openmath/PackageInfo.g") :=
    "@(#)$Id: PackageInfo.g,v 1.11 2006/01/03 14:47:04 gap Exp $";


SetPackageInfo( rec(
PackageName := "openmath",
Subtitle := "OpenMath functionality in GAP",


Version := "06.01.03",
Date := "03/01/2006",


ArchiveURL := Concatenation([
 "http://www-math.science.unitn.it/~costanti/gap_code/openmath/openmath-",
  ~.Version]),
ArchiveFormats := ".tar.gz",


Persons := [
  rec(
  LastName := "Solomon",
  FirstNames := "Andrew",
  IsAuthor := true,
  IsMaintainer := false,
  Email := "andrew@illywhacker.net",
  WWWHome := "http://www.illywhacker.net/",
  PostalAddress := Concatenation( [
    "Faculty of IT\n",
    "University of Technology, Sydney\n",
    "Broadway, NSW 2007\n",
    "Australia" ] ),
  Institution := "Faculty of Information Technology, University of Technology, Sydney."
 
  ),

  rec(
  LastName := "Costantini",
  FirstNames := "Marco",
  IsAuthor := true,
  IsMaintainer := true,
  Email := "costanti@science.unitn.it",
  WWWHome := "http://www-math.science.unitn.it/~costanti/",
  Place := "Trento",
  Institution := "Department of Mathematics, University of Trento"
  ),

],

Status := "deposited",
#CommunicatedBy := "",
#AcceptDate := "",


README_URL := "http://www-math.science.unitn.it/~costanti/gap_code/openmath/README",
PackageInfoURL :=
 "http://www-math.science.unitn.it/~costanti/gap_code/openmath/PackageInfo.g",


AbstractHTML := "This package has been developed to allow \
<span class=\"pkgname\">GAP</span> users to import and export \
mathematical objects encoded in \
<A HREF=\"http://www.openmath.org/\">OpenMath</A>, for the purpose of \
exchanging them with other applications which are OpenMath enabled.",


PackageWWWHome := "http://www-math.science.unitn.it/~costanti/#openmath",


PackageDoc := rec(
  BookName  := "OpenMath",
  ArchiveURLSubset := ["doc"],
  HTMLStart := "doc/chapters.htm",
  PDFFile   := "doc/manual.pdf",
  SixFile   := "doc/manual.six",
  LongTitle := "OpenMath functionality in GAP",
  Autoload  := true
),

Dependencies := rec(
  GAP := ">=4.4.2",
  NeededOtherPackages := [  ],
  SuggestedOtherPackages := [  ],
  ExternalConditions := [ "This package can be useful only with other applications that support ",
[ "OpenMath", "http://www.openmath.org" ] ]
),

AvailabilityTest := ReturnTrue,

Autoload := false,

# the banner
BannerString := 
"OpenMath package, by Andrew Solomon and Marco Costantini\n",


TestFile := "tst/test_new",


Keywords := ["OpenMath", "OpenMath Phrasebook"]

));

